// code by jph

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
import javax.swing.*;
import javax.swing.event.*;

public class VectorMail
implements ActionListener
{
  JFrame myJFrame=new JFrame("VectorMail Quokka");
  
  JComboBox[] myJComboBox=new JComboBox[2];
  static final int TEX=0;
  static final int EML=1;

  JButton[] myJButton=new JButton[5];
  static final int REF=0;
  static final int GOL=1;
  static final int GOR=2;
  static final int TST=3;
  static final int SND=4;
    
  JTabbedPane myJTabbedPane=new JTabbedPane();
  ClassLoader myClassLoader=getClass().getClassLoader();
  static final int TAB=0;
  static final int TXT=1;
  JTable myJTable;
  JLabel myJLabel=new JLabel("",null,JLabel.LEFT);
  JTextArea myJTextArea=new JTextArea();

  String master="";
  int index=0;
  int ferry=-1;
  
  String subject="Mail";
  String attach;
  
  HashMap<String,String> myHashMap=new HashMap<String,String>();

  public static void main(String[] args) {
    VectorMail myVectorMail=new VectorMail();
  }

  public VectorMail() {
    Container myContainer=myJFrame.getContentPane();
    myContainer.setLayout(new BorderLayout());    
    JToolBar myJToolBar=new JToolBar();
    myJToolBar.setFloatable(false);
    myJComboBox[TEX]=new JComboBox(new File("get").listFiles(new FilenameFilter() {
      public boolean accept(File myFile,String myString) {
        return new File(myFile+File.separator+myString).isDirectory();
      }
    }));
    myJComboBox[TEX].setPreferredSize(new Dimension(100, 27));
    myJComboBox[TEX].addActionListener(this);
    myJComboBox[TEX].setToolTipText("Select a folder.");
    myJToolBar.add(myJComboBox[TEX]);
    myJToolBar.addSeparator();
    myJButton[REF]=new JButton("",new ImageIcon(myClassLoader.getResource("res/icon.rcy.gif")));
    myJButton[REF].addActionListener(this);
    myJButton[REF].setToolTipText("Refresh.");
    myJToolBar.add(myJButton[REF]);
    myJToolBar.addSeparator();
    myJButton[GOL]=new JButton("",new ImageIcon(myClassLoader.getResource("res/icon.arl.png")));
    myJButton[GOL].addActionListener(this);
    myJButton[GOL].setToolTipText("Loop to left.");
    myJToolBar.add(myJButton[GOL]);
    myJButton[GOR]=new JButton("",new ImageIcon(myClassLoader.getResource("res/icon.arr.png")));
    myJButton[GOR].addActionListener(this);
    myJButton[GOR].setToolTipText("Loop to right.");
    myJToolBar.add(myJButton[GOR]);
    myJComboBox[EML]=new JComboBox();
    myJComboBox[EML].setPreferredSize(new Dimension(250, 27));
    myJComboBox[EML].addActionListener(this);
    myJComboBox[EML].setToolTipText("Select a recipient.");
    myJToolBar.add(myJComboBox[EML]);
    myJToolBar.addSeparator();
    myJButton[TST]=new JButton("",new ImageIcon(myClassLoader.getResource("res/icon.det.gif"))); // icon.aba.gif // icon.man.gif
    myJButton[TST].addActionListener(this);
    myJButton[TST].setToolTipText("Send this mail to yourself.");
    myJToolBar.add(myJButton[TST]);
    myJToolBar.addSeparator();
    myJButton[SND]=new JButton("",new ImageIcon(myClassLoader.getResource("res/icon.ppl.gif")));
    myJButton[SND].addActionListener(this);
    myJButton[SND].setToolTipText("Send all emails.");
    myJToolBar.add(myJButton[SND]);
    myContainer.add("North",myJToolBar);
    myJTable=new JTable();
    myJTabbedPane.add(new JScrollPane(myJTable),TAB);
    myJTabbedPane.setTitleAt(TAB,"Vector");
    myJTabbedPane.setIconAt(TAB,new ImageIcon(myClassLoader.getResource("res/icon.dte.gif")));
    JPanel myJPanel=new JPanel(new BorderLayout());
    myJTextArea.setLineWrap(true);
    myJTextArea.setWrapStyleWord(true);
    myJPanel.add("Center",new JScrollPane(myJTextArea));
    myJPanel.add("South",myJLabel);
    myJTabbedPane.add(myJPanel,TXT);
    myJTabbedPane.setTitleAt(TXT,"Mail");
    myJTabbedPane.setIconAt(TXT,new ImageIcon(myClassLoader.getResource("res/icon.ntp.gif")));    
    myContainer.add("Center",myJTabbedPane);
    Properties myProperties=getProperties("get"+File.separator+"VectorMail.properties");
    myJFrame.setLocation( Integer.parseInt(myProperties.getProperty("frame.x","50")),
                          Integer.parseInt(myProperties.getProperty("frame.y","50")));
    myJFrame.setSize(     Integer.parseInt(myProperties.getProperty("frame.width","400")),
                          Integer.parseInt(myProperties.getProperty("frame.height","500")));
    myJFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    actionPerformed(new ActionEvent("",0,""));
    myJFrame.setVisible(true);
  }

  public void actionPerformed(ActionEvent myActionEvent) {
    int c1;
    if ((myActionEvent.getSource()==myJComboBox[TEX]||myActionEvent.getSource()==myJButton[REF])&&0<myJComboBox[TEX].getItemCount()) {
      ferry=index;
      master="";
      try {
        DataInputStream myDataInputStream;
        String line;
        myDataInputStream=new DataInputStream(new BufferedInputStream(new FileInputStream(getDirectory()+"mail.tex")));
        while ((line=myDataInputStream.readLine())!=null) {
          line=line.trim();
          if (line.length()>0) {
            if (line.charAt(0)!='%')
              master+=line+" ";
          } else
            master+="\\\\ ";
        }
        myDataInputStream.close();
        master=master.replace("|","@");
        try {
          int rows,cols;
          myJComboBox[EML].removeAllItems();
          java.util.List<String> myList=new LinkedList<String>();
          myDataInputStream=new DataInputStream(new BufferedInputStream(new FileInputStream(getDirectory()+"vector.csv")));
          rows=cols=0;
          while ((line=myDataInputStream.readLine())!=null)
            if (0<line.trim().length()) {
              line=line.replace("|","@");
              myList.add(line);
              rows++;
              String[] mySplit=line.split(";");
              myJComboBox[EML].addItem(mySplit[0]);
              cols=Math.max(cols,mySplit.length);
            }          
          myDataInputStream.close();          
          String[][] myString=new String[rows][cols+1];
          rows=0;
          for (String myLine : myList) {
            c1=0;
            for (String myToken : myLine.split(";"))
              myString[rows][c1++]=myToken;
            for (;c1<cols;c1++)
              myString[rows][c1]="";
            rows++;
          }
          String[] heads=new String[cols];
          if (0<cols)
            heads[0]="email";
          for (c1=1;c1<cols;c1++)
            heads[c1]="#"+c1;
          myJTable=new JTable(myString,heads);
          myJTable.setRowHeight(20);
          myJTable.setIntercellSpacing(new Dimension(2,2));
          myJTabbedPane.setComponentAt(TAB,new JScrollPane(myJTable));
        } catch (IOException myIOException) {
          System.out.println(myIOException);
        }
      } catch (IOException myIOException) {
        System.out.println(myIOException);
      }      
    }
    if (myActionEvent.getSource()==myJButton[TST])
      sendMessage(getProperties(getDirectory()+"auth.properties").getProperty("user").replace("|","@"));
    if (myActionEvent.getSource()==myJButton[SND]) {
      c1=index;
      for (index=0;index<myJTable.getRowCount();index++)
        sendMessage((String)myJTable.getValueAt(index,0));
      index=c1;
    }
    if (myActionEvent.getSource()==myJButton[GOL])
      index--;
    if (myActionEvent.getSource()==myJButton[GOR])
      index++;
    if (myActionEvent.getSource()==myJComboBox[EML]&&0<myJComboBox[EML].getItemCount())
    	if (ferry<0)
  	    index=myJComboBox[EML].getSelectedIndex();
  	  else {
    	  index=ferry;
  	    ferry=-1;
	    }
	  boolean myBoolean=0<myJTable.getRowCount();
    if (myBoolean) {
      index+=myJTable.getRowCount();
      index%=myJTable.getRowCount();
      if (index<myJComboBox[EML].getItemCount()&&index!=myJComboBox[EML].getSelectedIndex())
        myJComboBox[EML].setSelectedIndex(index);
      myJTextArea.setText(callParse());
      myJTabbedPane.setTitleAt(TXT,subject);
      myJLabel.setText(attach);
      if (0<attach.length())
        myJLabel.setIcon(new ImageIcon(myClassLoader.getResource("res/icon.cli.gif")));
      else
        myJLabel.setIcon(null);
    }
    myJComboBox[EML].setEnabled(myBoolean);
    for (c1=GOL;c1<=SND;++c1)
      myJButton[c1].setEnabled(myBoolean);
  }
  
  void sendMessage(String toAddress) {
    String myToken;
    try {
      String fromAddress=getProperties(getDirectory()+"auth.properties").getProperty("user").replace("|","@");
      System.out.println(fromAddress+" > "+toAddress);
      javax.mail.Authenticator myAuthenticator=new SMTPAuthenticator();
      Session mySession=Session.getDefaultInstance(getProperties(getDirectory()+"server.properties"),myAuthenticator);
      mySession.setDebug(true);
      Message myMessage=new MimeMessage(mySession);
      myMessage.setFrom(new InternetAddress(fromAddress));
      myMessage.setRecipient(Message.RecipientType.TO,new InternetAddress(toAddress));
      myMessage.setSubject(subject);
      BodyPart myBodyPart;
      Multipart myMultipart=new MimeMultipart();
      myBodyPart=new MimeBodyPart();
      myBodyPart.setText(callParse());
      myMultipart.addBodyPart(myBodyPart);
      StringTokenizer myStringTokenizer=new StringTokenizer(attach," ",false);
      while (myStringTokenizer.hasMoreTokens()) {
        myToken=myStringTokenizer.nextToken();
        myBodyPart=new MimeBodyPart();
        myBodyPart.setDataHandler(new DataHandler(new FileDataSource(getDirectory()+"files"+File.separator+myToken)));
        myBodyPart.setFileName(myToken);
        myMultipart.addBodyPart(myBodyPart);
      }
      myMessage.setContent(myMultipart);          
      Transport.send(myMessage);
      System.out.println(" done.");
    } catch (MessagingException myMessagingException) {
      System.out.println(myMessagingException);
    }
  }
  
  private class SMTPAuthenticator extends javax.mail.Authenticator {
    public javax.mail.PasswordAuthentication getPasswordAuthentication() {
      String fromAddress=getProperties(getDirectory()+"auth.properties").getProperty("user").replace("|","@");
      String myString=myHashMap.get(fromAddress);
      if (myString==null)
        myString=JOptionPane.showInputDialog(myJFrame, "authenticate "+fromAddress,"enter password for this session", JOptionPane.QUESTION_MESSAGE);
      if (myString==null)
      return null;
      myHashMap.put(fromAddress,myString);
      return new javax.mail.PasswordAuthentication(
        fromAddress,
        myString);
    }
  }
  
  boolean hasNewline;
  boolean hasSpacing;
  
  public String callParse() {
    hasNewline=true;
    hasSpacing=true;
    attach="";
    String myString=master;
    for (int c1=0;c1<myJTable.getColumnCount();c1++)
      myString=myString.replace("#"+c1,(String)myJTable.getValueAt(index,c1));
    return parse(myString);
  }
  
  // recursive function operating on globals
  public String parse(String current) {
    int c1=0,c2=0,c3=0;
    int mode=1;
    String myString="";
    String myToken;
    String[] argum;
    StringTokenizer myStringTokenizer=new StringTokenizer(current," \\{}",true);
    int head=0;
    while (myStringTokenizer.hasMoreTokens()) {
      myToken=myStringTokenizer.nextToken();
      head+=myToken.length();
      if (myToken.equals("\\")) { // 
        myToken=myStringTokenizer.nextToken();
        head+=myToken.length();          
        if (myToken.equals("\\")) 
          if (!hasNewline) {
            myString+="\n";
            hasNewline=true;
            hasSpacing=true;
          }
        if (myToken.equals("#")) {
          myString+="#";
          hasSpacing=true;
        }
        if (myToken.equals("bigskip")) {
          if (!hasNewline)
            myString+="\n\n";
          else
            myString+="\n";
          hasNewline=true;
          hasSpacing=true;
        }
        if (myToken.equals("to")) { //    \to {0} {1} 2
          argum=arguments(current.substring(head),2);
          myStringTokenizer=new StringTokenizer(current=argum[2]," \\{}",true); // wtf !?
          head=0;
          if (0<=argum[0].indexOf(""+myJTable.getValueAt(index,0)))
            myString+=parse(argum[1]);
        }
        if (myToken.equals("title")) { //    \title {0} 1
          argum=arguments(current.substring(head),1);
          myStringTokenizer=new StringTokenizer(current=argum[1]," \\{}",true);
          head=0;
          subject=parse(argum[0]);
        }
        if (myToken.equals("emptyset")) { //     \emptyset {0} {1} {2} 3
          argum=arguments(current.substring(head),3);
          myStringTokenizer=new StringTokenizer(current=argum[3]," \\{}",true);
          head=0;
          String mySet=parse(argum[0]);
          if (mySet.trim().isEmpty())
            myString+=parse(argum[1]);
          else
            myString+=mySet+parse(argum[2]);
        }
        if (myToken.equals("appendix")) { //     \appendix {0} 1
          argum=arguments(current.substring(head),1);
          myStringTokenizer=new StringTokenizer(current=argum[1]," \\{}",true);
          head=0;
          attach+=argum[0]+"    ";
        }
      } else
        if (myToken.equals(" ")) {
          if (!hasSpacing) {
            myString+=" ";
            hasSpacing=true;
          }
        } else {
          myString+=myToken;
          hasNewline=false;
          hasSpacing=false;
        }
    }
    return myString;
  }
  
  public static String[] arguments(String myString,int myInt) {
    int c1=0;
    int numbr=-1;
    int depth=0;
    String[] argum=new String[myInt+1];
    for (c1=0;c1<=myInt;c1++)
      argum[c1]="";
    for (c1=0;c1<myString.length();c1++) {
      if (myString.charAt(c1)=='}')
        depth=Math.max(0,depth-1);
      if (0<=numbr&&0<depth)
        argum[numbr]+=myString.charAt(c1);
      if (numbr==myInt-1&&depth==0)
        break;
      if (myString.charAt(c1)=='{')
        if (++depth==1)
          numbr++;      
    }
    argum[myInt]=myString.substring(c1+1);
    for (c1=0;c1<myInt;c1++)
      argum[c1]=argum[c1].trim();
    return argum;
  }
  
  String getDirectory() {
    return myJComboBox[TEX].getSelectedItem()+File.separator;
  }
  
  static Properties getProperties(String myString) {
    Properties myProperties=new Properties();
    try {
      FileInputStream myFileInputStream=new FileInputStream(myString);
      myProperties.load(myFileInputStream);
      myFileInputStream.close();
    } catch (Exception myException) {
      System.out.println(myException);
    }
    return myProperties;
  }
  
}
